﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SharedStore
{
  // A delegate type for hooking up change notifications.
  public delegate void ChangedEventHandler(object sender, EventArgs e);

  class Store
  {
    // An event that clients can use to be notified whenever the
    // elements of the list change.
    public event ChangedEventHandler Changed;

    // The Store-Content
    private String _strText;

    public Store()
    {
      _strText = String.Empty;
    }

    // Invoke the Changed event; called whenever list changes
    protected void OnChanged(EventArgs e)
    {
      if (Changed != null)
        Changed(this, e);
    }

    public String Text
    {
      get { return _strText; }
      set 
      {
        _strText = value;
        //Call Eventhandlers...
        OnChanged(EventArgs.Empty);
      }
    }

    
  }
}
